import { BaseRepository } from '#application/base/baseRepository'
import { CharacterType } from '#entities/characterType'

class CharacterTypeRepository extends BaseRepository {
  async getFirst() {
    try {
      const repository = this.em.getRepository(CharacterType)
      return await repository.findOne({ id: { $exists: true } })
    } catch (error: any) {
      this.logger.error(`Failed to get first character type: ${error instanceof Error ? error.message : String(error)}`)
      return null
    }
  }

  async getAll() {
    try {
      const repository = this.em.getRepository(CharacterType)
      return await repository.findAll()
    } catch (error: any) {
      this.logger.error(`Failed to get all character types: ${error instanceof Error ? error.message : String(error)}`)
      return null
    }
  }

  async getById(id: number) {
    try {
      const repository = this.em.getRepository(CharacterType)
      return await repository.findOne({ id })
    } catch (error: any) {
      this.logger.error(`Failed to get character type by ID: ${error instanceof Error ? error.message : String(error)}`)
      return null
    }
  }
}

export default new CharacterTypeRepository()
